// smstatus.js
// XMLHttpRequest objects
var sxinit = false;  // initial sequencer
var sxstatus1 = false; // get data from status command
var sxstatus2 = false; // get data from test results command

// get the xmlHttp request object - browser dependent
if (window.XMLHttpRequest)
  {
  sxinit = new XMLHttpRequest();
  sxstatus1 = new XMLHttpRequest();
  sxstatus2 = new XMLHttpRequest();
  }
else if (window.ActiveXObject)
  {
  sxinit = new ActiveXObject("Microsoft.XMLHTTP");
  sxstatus1 = new ActiveXObject("Microsoft.XMLHTTP");
  sxstatus2 = new ActiveXObject("Microsoft.XMLHTTP");
  }
else
  {
  alert("Browser does not support xmlHttpRequest object - need to upgrade");
  }

// timeoutid's : one for each xmlhHTTP object
var timeoutidinit;
var timeoutidact;
var timeoutidstat1;
var timeoutidstat2;
// and one for refresh timer - when to do another reading
var refreshtimerid;

var numtimeouts;  // for sequencer or auto: error timeouts only
var refreshtime;  // how often to refresh status: 0 means never

var url = "status.cgi";

var sequencecount = 6;
var sequencelist = new Array(6);
var sequencendx;
// string tells what to do: start with C or S
sequencelist[0] = "CVA";  // main firmware
sequencelist[1] = "CVR";  // Rabbit firmware
sequencelist[2] = "SI";    // serial number(s)
sequencelist[3] = "CIC";  // current IP etc.
sequencelist[4] = "SS";   // status
sequencelist[5] = "ST?";  // and test results too




// table for general alarms: do as in NC8
// making it easier to add rows etc.
var numalarms = 9
var lrmlist=new Array(9);
lrmlist[0]  =  "1:  internal leak";
lrmlist[1]  =  "2:  high duty cycle";
lrmlist[2]  =  "3:  low pressure";
lrmlist[3]  =  "4:  high pressure";
lrmlist[4]  =  "5:  low temperature";
lrmlist[5]  =  "6:  high temperature";
lrmlist[6]  =  "7:  EEROM corrupted";
lrmlist[7]  =  "8:  Unable to pressurize";
lrmlist[8]  =  "9:  Switched operating mode";

var isalarm;    // so can say "none" instead
var ismessage;  // ditto, for messages
		// also used to construct info string
var lrmstring;  // generated by processalarms, if there are any
var msgstring;  // from processmessages

function doalert(str)
// really want to put in alert field - later
  {
  alert(str);
  }

function sysalert(str)
// should be impossible; error in Javascript
  {
  alert("SYSTEM ERROR:\n" + str);
  }


function disorenableall(dis)
  {
  // enable or disable all the user buttons - for initialization
  // only one now - keep in case we add more later
  document.getElementById("getstatus").disabled=dis;
  }

function findkeypos(str)
  {
  // return the position of the "key" in str
  // key can be ! or _ or : or ^
  // has to be 0, 1, or 2: else no key, return0
  var pos;
  pos = str.search(/[\!\:\_\^]/);
  if (pos==-1) pos=0;
  if (pos>2) pos=0;
  return pos;
  }


function status_initialize()
  {
  var but;
  // set auto refresh to 3 seconds
  refreshtime=3000;
  but=document.refreshform.rgroup;
  but[0].checked=0;  // .5 sec
  but[1].checked=0;  // 1 sec
  but[2].checked=1;  // 3 sec
  but[3].checked=0;  // 10 sec
  but[4].checked=0;  // off
  // start sequencer
//  document.getElementById("alertspan").innerHTML = "initializing...";
  sequencendx=0;
  numtimeouts=0;
  disorenableall(1);  // no user input allowed
  dosequencer();  // will enable buttons and start refresh when done
  }


function dosequencer()
  {
  var url;
  var ajaxmsg;
  var x;
  x=sequencelist[sequencendx].charAt(0);
  if (x=='C') url="config.cgi";
  else if (x=='S') url="status.cgi";
  else
    {
    doalert("Bad sequencer element - aborting");
    return;
    }
  ajaxmsg = sequencelist[sequencendx].slice(1);  // start after first char
  if ( (sxinit.readyState==4) || (sxinit.readyState==0) )
    {
    sxinit.open("POST", url, true);
    sxinit.onreadystatechange = sxinitreturn;
    sxinit.send(ajaxmsg);
    timeoutidinit = window.setTimeout("timeoutrtninit();", 1000);
    }
  else
    {
    doalert("Sequencer stuck - aborting");
    return;
    }
  }


function timeoutrtninit()
  {
  // get here if sequencer times out - allow 5 before alerting
  // no - not alerting at all now; but might put back in
  numtimeouts++;
// if (numtimeouts>=5)
//  doalert("Warning: initializer has failed " + numtimeouts + " times so far");
  dosequencer();  // continue to try
  }

function sxinitreturn()
  {
  var str0;
  var keypos;
  var str1;
  var splitstr;
  // check to see if finished
  if ( (sxinit.readyState==4) && (sxinit.status==200) )
    {
    // get it! process
    window.clearTimeout(timeoutidinit);
    numtimeouts=0;
    str0 = sxinit.responseText;
    keypos = findkeypos(str0);
    if (str0.charAt(keypos) != ":")
      {
      // error return - should be impossible
      doalert("Unexpected response [" + str0 + "]");
      dosequencer();  // keep retrying
      return;
      }
    // here, is ok
    // we know where it came from: don't need to parse
    str1 = str0.slice(keypos+1);
    badresp=0;  // default
    if (sequencendx==0)
	{
	// VA to config: get main firmware
	splitarray = str1.split("$");
	if (splitarray.length!=4) badresp=1;
	document.getElementById("mainfw").innerHTML = splitarray[0];
	}
    else if (sequencendx==1)
	{
	// VR to config: get comm firmware
	document.getElementById("commfw").innerHTML = str1;
	}
    else if (sequencendx==2)
	{
	// I to status: get serial numbers
	splitarray = str1.split(";");
	if (splitarray.length!=3) badresp=1;
	document.getElementById("sernum").innerHTML = splitarray[2];
	}
    else if (sequencendx==3)
	{
	// IC to config: current IP etc.
	splitarray = str1.split(";");
	if (splitarray.length!=6) badresp=1;
	document.getElementById('currentip').innerHTML = splitarray[0];
	document.getElementById('currentmask').innerHTML = splitarray[1];
	document.getElementById('currentgate').innerHTML = splitarray[2];
	document.getElementById('currentname').innerHTML = splitarray[3];
	document.getElementById('currentmac').innerHTML = splitarray[4];
	}
    else if (sequencendx==4)
	{
	// S to status: main status info
	badresp = parsestatusreturn(str1);  // puts in place
	}
    else if (sequencendx==5)
	{
	// T? to status: test info
	badresp = parsetestinfo(str1);  // puts in place
	}
    else
	{
	sysalert("Error: sequencendx=" + sequencendx);
	sequencendx=5;  // abort sequence
	}
    if (badresp) doalert("Bad response: [" + str0 + "]");
    if (sequencendx==5)
	{
	// end of sequencer
	sequencendx=0;
	status_endinit();
	}
    else
	{
	sequencendx++;
	dosequencer();
	}
    }
  }

function status_endinit()
  {
  // get here when initialization is done
  var elt;
  disorenableall(0);  // user input allowed
  setrefresh(refreshtime);
  }


function setrefresh(param)
  {
  refreshtime = param;
  window.clearTimeout(refreshtimerid);
  if (refreshtime)
	{
	document.getElementById("getstatus").disabled=true;
        refreshtimerid=window.setTimeout("refreshrtn();", refreshtime);
	}
  else document.getElementById("getstatus").disabled=false;
  }


function refreshrtn()
  {
  // gets called when refresh timer runs out: just get info
  getstatus();
  }




function condalert(str)
{
// do NOT want to alert timeouts etc when doing automatics
// since nobody is there maybe to clear it!
if (refreshtime==0) alert(str);
}

function condgetstatus()
{
// do not do it if refresh is off
if (refreshtime==0) getstatus();
}


function getstatus()
  {
  // get status info from ADH, display on screen when returns
  // do both the 'S' and the 'T?' commands
  if  ( 
	( (sxstatus1.readyState==4) || (sxstatus1.readyState==0) )
        &&
	( (sxstatus2.readyState==4) || (sxstatus2.readyState==0) )
      )
     {
     // ok to do it: set up as POST request
     sxstatus1.open("POST", url, true);  // asynchronous, POST
     // set up function to be called when state changes
     sxstatus1.onreadystatechange = getstatusreturn;
     sxstatus1.send('S');
     timeoutidstat1 = window.setTimeout("timeoutrtns1();", 1000);
     // and the "T?" too
     sxstatus2.open("POST", url, true);  // asynchronous, POST
     // set up function to be called when state changes
     sxstatus2.onreadystatechange = gettestreturn;
     sxstatus2.send('T?');
     timeoutidstat2 = window.setTimeout("timeoutrtns2();", 1000);
     }
  else condalert("Busy");
  }


function timeoutrtns1()
  {
  // gets called if the xmlhttp request times out
  // clear it and reenable the window; also alert
  // this for status1: status
  sxstatus1.abort();
  condalert("Request timed out");
// and restart timer
  window.clearTimeout(refreshtimerid);
  if (refreshtime)
       refreshtimerid=window.setTimeout("refreshrtn();", refreshtime);
  }

function timeoutrtns2()
  {
  // gets called if the xmlhttp request times out
  // clear it and reenable the window; also alert
  // this for status2: test results
  sxstatus2.abort();
  condalert("Request timed out");
// and restart timer
  window.clearTimeout(refreshtimerid);
  if (refreshtime)
       refreshtimerid=window.setTimeout("refreshrtn();", refreshtime);
  }

function getstatusreturn()
  {
  var instr0;
  var instr1;
  var splitarray;   // 6 fields,with terminating semicolon
  var keypos;
  var badresp;
  // check to see if finished
  if ((sxstatus1.readyState==4) && (sxstatus1.status==200) )  
    {
    window.clearTimeout(timeoutidstat1);
    window.clearTimeout(refreshtimerid);
    if (refreshtime)
       refreshtimerid=window.setTimeout("refreshrtn();", refreshtime);
    // write values into form, IF valid
    instr0 = sxstatus1.responseText;
    keypos = findkeypos(instr0);
    instr1 = instr0.slice(keypos+1);
    badresp = parsestatusreturn(instr1);
    if (badresp) doalert("Bad response: [" + str0 + "]");
    }
  }

function gettestreturn()
  {
  var instr0;
  var instr1;
  var splitarray;   // 6 fields,with terminating semicolon
  var keypos;
  var badresp;
  // check to see if finished
  if ((sxstatus2.readyState==4) && (sxstatus2.status==200) )  
    {
    window.clearTimeout(timeoutidstat2);
    window.clearTimeout(refreshtimerid);
    if (refreshtime)
       refreshtimerid=window.setTimeout("refreshrtn();", refreshtime);
    // write values into form, IF valid
    instr0 = sxstatus2.responseText;
    keypos = findkeypos(instr0);
    instr1 = instr0.slice(keypos+1);
    badresp = parsetestinfo(instr1);
    if (badresp) doalert("Bad response: [" + str0 + "]");
    }
  }


function parsestatusreturn(instr)
  {
  // parse status return message; return 1 if bad
  // put results into the appropriate fields
  var splitarray;
  var ok;
  var retval;
  ok=1;
  splitarray = instr.split(";");
  if (splitarray.length != 7) return 1; // error
  // process info - no parsing yet
  document.getElementById('pressure').innerHTML = splitarray[0];
  document.getElementById('temperature').innerHTML = splitarray[1];
  document.getElementById('dutycycle').innerHTML = splitarray[2];
  processstatus(splitarray[3]);
  retval = processalarms(splitarray[4]);
  if (retval) ok=0;
  processmessages(splitarray[5]);
  if (!ok) return 1;
  // ok: install messages/alarms into info bar
  if (isalarm)
    {
    document.getElementById("statusdiv").className = "col_460 alarm";
    // make it red
    if (ismessage)
      document.getElementById('infos').innerHTML = lrmstring+msgstring;
    else
      document.getElementById('infos').innerHTML = lrmstring;
    }
  else if (ismessage)
    {
    document.getElementById("statusdiv").className = "col_460 warning";
    // make it yellow
    document.getElementById('infos').innerHTML = msgstring;
    }
  else
    {
    document.getElementById("statusdiv").className = "col_460 noalarms";
    // make it green
    document.getElementById('infos').innerHTML = "No alarms or messages";
    }
  return 0;
  }


function processstatus(str)
  {
  // str is returned status portion of string
  // ex: NI+X-O+O+X-X-X-B- : + is on, - is off; lower case if disabled
  // changed: now followed by + or - = alive/dead: IOC only: this is "cond"
  var x;
  var portnum;
  var elt;
  var msg;
  var abbrev;
  var strndx;
  x=str.charAt(0);
  strndx=1;
  // put op mode into table, as abbrev, and into opmode
  abbrev=x;
  if (x=="S") msg="Standalone";
  else if (x=='R')
     {
     msg="Redundant (using port " + str.charAt(1) + ")" ;
     abbrev = abbrev+str.charAt(1);
     strndx=2;
     }
  else if (x=='P') msg="Parallel";
  else if (x=='T') msg="Testing";
  else if (x=='I') msg="Transient";
  else if (x=='X') msg="PROBLEM";
  else if (x=='C') msg="Comm init.";
  else if (x=='M') msg="Manual";
  else if (x=='O') msg="Offline";
  else msg="???";
//  elt =   document.getElementById('systype');
//  elt.innerHTML = abbrev;
// this is if need single- or double-letter abbreviations
  elt =   document.getElementById('opmode');
  elt.innerHTML = msg;
  for (portnum=1; portnum<=8; portnum++)
    {
    x=str.charAt(strndx);
    strndx++;
    if (x=='X') msg="---";
    else if (x=='I') msg="Input";
    else if (x=='i') msg="In (dis)";
    else if (x=='O') msg="Output";
    else if (x=='o') msg="Out(dis)";
    else if (x=='C') msg="CritOut";
    else if (x=='c') msg="CritOut(dis)";
    else if (x=='B') msg="Bleed";
    else msg="???";
    elt = document.getElementById('port' + portnum + 'type');
    elt.innerHTML = msg;
    if ( (x=='I') || (x=='O') || (x=='C') )
	{
	// IOC: followed by condition = alive/dead
	x=str.charAt(strndx);
	strndx++;
	if (x=='+') msg="Active";
	else if (x=='-') msg="Dead";
	else msg="????";
	elt = document.getElementById('port' + portnum + 'cond');
	elt.innerHTML = msg;
	}
    else
	{
	// not IOC: just erase cond
	elt = document.getElementById('port' + portnum + 'cond');
	elt.innerHTML = "";
	}
    }
  }

function processalarms(str)
  {
  // return 1 if error
  // str is returned status portion of string
  // is 4 hex digits for globals
  // plus 8 pairs of hex digits for locals
  // total length is 20
  // NO: added a decimal point before alarms for disabled ports
  // check length when done processing
  var hexval;
  var ndx;
  var substr;
  var lrmmask;
  var lrmndx;
  var useparen;
  var loc;
    // make sure all ok hex digits
    // use reg. ex. match
  if (str.match(/[^0-9A-Fa-f\.]/) != null)  return 1;  // unexpected string
  // here, is ok: 20 hex digits = 10 bytes of data
  isalarm=0;  // set to 1 if get one coming in
  lrmstring="";  // append to it
  // first 4 bytes is general alarms
  hexval = parseInt(str.substring(0,4),16);
  for (lrmndx=0,lrmmask=1; lrmndx<16; lrmndx++, lrmmask<<=1)
     {
     if ( (hexval&lrmmask) != 0)
	{
	// is set
	isalarm=1;
	if (lrmndx<numalarms) substr = lrmlist[lrmndx];
	else substr = "Alarm # " + (lrmndx+1);
	lrmstring = lrmstring + substr + "<br />";
	}
     }
    // now the individual port alarms
  loc = 4;
  for (ndx=0; ndx<8; ndx++)
     {
     if (str.charAt(loc) == ".")
	{
	loc++;
	useparen=1;
	}
     else useparen=0;
     hexval = parseInt(str.substring(loc, loc+2), 16);
     loc += 2;
     if (hexval!=0)
	{
	// is an alarm for port ndx+1
	isalarm=1;
	if (useparen)
	  substr = "(Port " + (ndx+1) + ":" ;
	else
	  substr = "Port " + (ndx+1) + ":" ;
	if (hexval&0x01) substr = substr + " In warning";
	if (hexval&0x02) substr = substr + " In alarm";
	if (hexval&0x04) substr = substr + " No pres";
	if (hexval&0x08) substr = substr + " Comm err";
	if (hexval&0x10) substr = substr + " Out warning";
	if (hexval&0x20) substr = substr + " Out alarm";
	if (hexval&0x40) substr = substr + " Out critical";
	if (hexval&0x80) substr = substr + " Out shutdown";
	if (useparen) substr = substr + ")";
	lrmstring = lrmstring + substr + "<br />";
	}
     }
  if (str.length != loc) return 1;
  return 0;  //  ok
  }




function processmessages(str)
  {
  // str is series of 2-digit codes
  // EC EL ET EP: bad EE alarms
  // XD XP: warnings about no automatic testing
  // TA: warning that test was aborted, so time different
  // or is XX or blank if no messages
  var submsg;
  var ndx;
  var msgcode;
  if ( (str=="XX") || (str==""))
    {
    ismessage=0;
    return;
    }
  ismessage=1;
  msgstring="";
  for (ndx=0; ndx<str.length; ndx+=2)
    {
    msgcode = str.substring(ndx, ndx+2);
    if (msgcode=='EC') submsg="Calibrations corrupted";
    else if (msgcode=='EL') submsg="Pressure limits corrupted";
    else if (msgcode=='ET') submsg="Test parameters corrupted";
    else if (msgcode=='EP') submsg="Port types corrupted";
    else if (msgcode=='XD') submsg="Duty cycle will not trigger test";
    else if (msgcode=='XP') submsg="Low pressure will not trigger test";
    else if (msgcode=='XT') 
                  submsg="Failure to pressurize will not trigger test";
    else if (msgcode=='TA') submsg="Time-triggered test was aborted";
    else submsg="Unrecognized message code " + msgcode;
    msgstring = msgstring + submsg + "<br />";
    }
  }



function parsetestinfo(instr)
  {
  // parse status return message; return 1 if bad
  // put results into the appropriate fields
  var splitarray;
  var allok;
  var ok;  // one field
  var elt;
  var elt2;
  var elt3;
  var str;  // split away from input message
  var leakrate;  // what to put in leak rate
  var cond;  // ditto for cond
  var ndx;
  var ptype; 
  var timestr;
  var schar;
  var stat;
  splitarray = instr.split(";");
  if (splitarray.length != 11) return 1; // error
  // process info - set ok=0 if there is a problem
  // so can show the good parts
  allok=1;
  timestr = splitarray[0];
  // if 'X', replace with no test message
  if (timestr=='X') timestr="No test done";
  document.getElementById('testtime').innerHTML = timestr;
  // [1] is S- or S=...
  str = splitarray[1];
  ok=1;
  if (str.charAt(0) != 'S') ok=0;
  else if (str.charAt(1) == '-') leakrate='---';
  else if (str.charAt(1)=='=') leakrate = str.substring(2);
  else ok=0;
  if (!ok) leakrate='???';
  if (!ok) allok=0;
  elt=document.getElementById('sysleakrate');
  elt.innerHTML = leakrate;
  for (ndx=1; ndx<=8; ndx++)
    {
    // now has status=open/shut prepended, in any case
    str = splitarray[ndx+1];
    elt = document.getElementById('port' + ndx + 'cond');
    elt2 = document.getElementById('port' + ndx + 'leakrate');
    elt3 = document.getElementById('port' + ndx + 'status');
    ok=1;
    ptype = str.charAt(0);
    schar = str.charAt(1);
    if (schar=='+') stat="Open";
    else if (schar=='-') stat="Shut";
    else stat="????";
    elt3.innerHTML = stat;
    if ( (ptype=='O') || (ptype=='C') || (ptype=='I') )
	{
	// input or output port: check for leak rate, condition
        // was done in other string too; repeat for later splitting
	if (str.charAt(2)=='+') cond="Active";
	else if (str.charAt(2)=='-') cond="Dead";
	else cond="???";
	if (str.charAt(3)=='-') leakrate="---";
	else if (str.charAt(3)=='=') leakrate = str.substring(4);
	else leakrate="???";
	}
    else if ( (ptype=='X') || (ptype=='B') )
	{
	// bleed or unused: just blank leak rate, condition
	cond="";
	leakrate="";
	}
    else if ( (ptype=='i') || (ptype=='o') || (ptype=='c') )
	{
	// same for inactive ports
	// no: now has leak rate, but not dead/alive thing
	cond="";
	if (str.charAt(2)=='-') leakrate="---";
	else if (str.charAt(2)=='=') leakrate = str.substring(3);
	else leakrate="???";
	}
    else
	{
	// error
	cond="???";
	leakrate="???";
	ok=0;
	}
    elt.innerHTML = cond;
    elt2.innerHTML = leakrate;
    if (!ok) allok=0;
    }
  if (!allok) return 1;
  return 0;
  }

